#!/usr/bin/perl
##############################################################################
# Site News script                     Version 1.1                           #
# Copyright 1999, UtilMind Solutions   info@utilmind.com                     #
# 				       http://www.utilmind.com               #
# Created: Jul 22, 1999                Last Modified: Jul 30, 1999           #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1999 UtilMind Solutions.  All Rights Reserved.                   #
#                                                                            #
# This program is being distributed as shareware. It may be used and         #
# modified free of charge for personal, academic, government or non-profit   #
# use, so long as this copyright notice and the header above remain intact.  #
# Any commercial use should be registered. Please also send us an email,     #
# and let us know where you are using this script. By using this program     #
# you agree to indemnify UtilMind Solutuons from any liability.              #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  Obtain permission before redistributing this         #
# program over the Internet or in any other medium.  In all cases            #
# copyright and header must remain intact.                                   #
#                                                                            #
# Please check the README file for full details on installation              #
# and registration.                                                          #
##############################################################################

### Set Variables

$mainurl = 'http://www.yourdomain.com/news.shtml'; # news page or site main url
$cgi_url = 'http://www.yourdomain.com/cgi-bin/sitenews.cgi'; # url of this file

$database = 'archive.html'; # news archive file name


### Passwords - please change them!

$add_password  = 'add';    # Password for news suppliers
$edit_password = 'edit';   # Password for editors



# Define arrays for the month of the year.

# English
@months = ('January','February','March','April','May','June','July',
           'August','September','October','November','December');

# Russian
# @months = ('','','','','','','',
#            '','','','','');


### Text font name

$fontname = "Arial, Helvetica";



### Colors styles and sizes of:

# News subject
$subject_color = "red";
$subject_size = 2;
$subject_bold = 1;
$subject_italic = 0;
$subject_underline = 0;

# Name of supplier
$name_size = 1;
$name_bold = 0;
$name_italic = 0;
$name_underline = 0;

# News time
$time_color = "gray";
$time_size = 1;
$time_bold = 0;
$time_italic = 0;
$time_underline = 0;

# News Issue
$issue_color = "navy";
$issue_size = 1;
$issue_bold = 0;
$issue_italic = 1;
$issue_underline = 0;

# Message (message color - default page color)
$msg_size = 2;
$msg_bold = 0;
$msg_italic = 0;
$msg_underline = 0;

$msg_justify = 1; # Do text justification. 0-No, 1-Yes

$dividertag = '<hr noShade>'; # Divider of messages

# Date format
$timezone     = 0;     # (0 - GMT)
$timezonename = 'GMT';


($min,$hour,$mday,$mon,$year) = (gmtime(time+$timezone*60*60))[1,2,3,4,5];
$year += 1900;
$time = sprintf("%02d:%02d",$hour,$min);
$date = "$time $timezonename, $mday $months[$mon]";

# if you would like to show year
# $date = "$time $timezonename, $mday $months[$mon] $year";


##########################################################
# No changes need to be made after these lines
##########################################################

open(FILE, $database) || "Can't open database file: $!";
@NEWS = <FILE>;
close(FILE);

&get_input_info;

if ($query eq 'add') {
  if ($FORM{'password'} ne $add_password) {
    print "Content-Type: text/html\n\n";
    print "<h1>Error: Invalid password</h1>";
    exit;
  }
  &add_news;
} elsif ($query eq 'edit') {
  print "Content-Type: text/html\n\n";

  print "<html><body><p>";
  print "<form method=\"POST\" action=\"$cgi_url?doedit\">";
  print "<font face=\"Arial, Helvetica\" size=\"2\"><b>Subjects to edit:</b></font><br>";
  print "<select name=\"subject\" size=\"1\">";
  foreach $str (@NEWS) {
    ($dummy, $subj ,$dummy) = split(/<!--s-->/, $str);
    print "<option>$subj";
    $i++;
    if ($i > 25) { last }
  }
  print "</select></p>";
  print "<p><font face=\"Arial, Helvetica\" size=\"2\"><b>Password for edition:</b></font><br>";
  print "<input type=\"password\" name=\"password\" size=\"26\"></p>";
  print "<p><input type=\"submit\" value=\"-= Edit =-\"></p>";
  print "</form>";

  print "</body></html>";
} elsif ($query eq 'doedit') {
  print "Content-Type: text/html\n\n";

  if ($FORM{'password'} ne $edit_password) {
    print "<h1>Error: Invalid password</h1>";
    exit;
  }
  foreach $str (@NEWS) {
    ($dummy, $subj, $dummy) = split(/<!--s-->/, $str);
    if ($FORM{'subject'} eq $subj) {
      ($dummy, $name, $dummy) = split(/<!--n-->/, $str);
      ($dummy, $issue, $dummy) = split(/<!--i-->/, $str);
      ($dummy, $message, $dummy) = split(/<!--m-->/, $str);
      last;
    }
  }

  print "<html><body><p>";
  print "<form action=\"$cgi_url?update\" method=post>\n";
  print "<input type=hidden name=\"password\" value=\"$FORM{'password'}\"><br>\n";
  print "<input type=hidden name=\"oldsubject\" value=\"$subj\"><br>\n";
  print "Subject: <input type=text name=\"subject\" size=20 value=\"$subj\"><br>\n";
  print "Name: <input type=text name=\"name\" size=20 value=\"$name\"><br>\n";
  print "Issue: <input type=text name=\"issue\" size=20 value=\"$issue\"><br>\n";
  print "Message:<br><textarea name=\"message\" rows=8 cols=80>$message</textarea><br>\n";
  print "<input type=\"submit\" VALUE=\"Update\"></form></b><p>\n";
  print "</body></html>\n";
} elsif ($query eq 'update') {

  if ($FORM{'password'} ne $edit_password) {
    print "Content-Type: text/html\n\n";
    print "<h1>Error: Invalid password</h1>";
    exit;
  }
  open(FILE, ">$database") || "Can't open database file for writing: $!";
  flock(FILE, 2); # disabling write access

  foreach $str (@NEWS) {
    ($prev, $subj, $next) = split(/<!--s-->/, $str);
    if ($FORM{'oldsubject'} ne $subj) {
      print FILE $str;
    } else {
      print FILE "$prev$FORM{'subject'}";
      
      ($prev, $name, $next) = split(/<!--n-->/, $next);

      print FILE "$prev$FORM{'name'}";

      ($prev, $issue, $next) = split(/<!--i-->/, $next);

      print FILE "$prev$FORM{'issue'}";

      ($prev, $message, $next) = split(/<!--m-->/, $next);

      print FILE "$prev$FORM{'message'}$next";
    }
  }

  flock(FILE, 8);
  close(FILE);

  print "Location: $mainurl\n\n";

} else {
  &show_news;
}
exit;


sub get_input_info {
  $query = $ENV{'QUERY_STRING'};

  read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

  @pairs = split(/&/, $buffer);

  foreach $pair (@pairs) {
     ($name, $value) = split(/=/, $pair);

     $value =~ tr/+/ /;
     $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
     $value =~ s/<!--(.|\n)*-->//g;

     $value =~ s/\n/<br>/g;

     $FORM{$name} = $value;
  }
}

sub add_news {
  open(FILE, ">$database") || "Can't open database file for writing: $!";
  flock(FILE, 2); # disabling write access
#-----------
  print FILE "<p><font face=\"$fontname\" color=\"$subject_color\" size=\"$subject_size\">";

  if ($subject_bold eq 1) { print FILE "<b>"; }
  if ($subject_italic eq 1) { print FILE "<i>"; }
  if ($subject_underline eq 1) { print FILE "<u>"; }
  print FILE "<!--s-->$FORM{'subject'}<!--s-->";
  if ($subject_underline eq 1) { print FILE "</u>"; }
  if ($subject_italic eq 1) { print FILE "</i>"; }
  if ($subject_bold eq 1) { print FILE "</b>"; }

  print FILE "</font><br>";
#----------
  print FILE "<font face=\"$fontname\" size=\"$name_size\"><a href=\"mailto:$FORM{'email'}\">";

  if ($name_bold eq 1) { print FILE "<b>"; }
  if ($name_italic eq 1) { print FILE "<i>"; }
  if ($name_underline eq 1) { print FILE "<u>"; }
  print FILE "<!--n-->$FORM{'name'}<!--n-->";
  if ($name_underline eq 1) { print FILE "</u>"; }
  if ($name_italic eq 1) { print FILE "</i>"; }
  if ($name_bold eq 1) { print FILE "</b>"; }

  print FILE "</a>, </font>";
#-----------
  print FILE "<font face=\"$fontname\" size=\"$time_size\" color=\"$time_color\">";
  if ($time_bold eq 1) { print FILE "<b>"; }
  if ($time_italic eq 1) { print FILE "<i>"; }
  if ($time_underline eq 1) { print FILE "<u>"; }
  print FILE $date;
  if ($time_underline eq 1) { print FILE "</u>"; }
  if ($time_italic eq 1) { print FILE "</i>"; }
  if ($time_bold eq 1) { print FILE "</b>"; }
  print FILE " </font> ";
#-----------
  print FILE "<font face=\"$fontname\" size=\"$issue_size\" color=\"$issue_color\">";
  if ($issue_bold eq 1) { print FILE "<b>"; }
  if ($issue_italic eq 1) { print FILE "<i>"; }
  if ($issue_underline eq 1) { print FILE "<u>"; }
  print FILE "| <!--i-->$FORM{'issue'}<!--i-->";
  if ($issue_underline eq 1) { print FILE "</u>"; }
  if ($issue_italic eq 1) { print FILE "</i>"; }
  if ($issue_bold eq 1) { print FILE "</b>"; }
  print FILE " </font></p>";
#-----------
  print FILE "<p";
  if ($msg_justify eq 1) { print FILE " align=\"justify\""; }
  print FILE "><font face=\"$fontname\" size=\"$msg_size\">";
  if ($msg_bold eq 1) { print FILE "<b>"; }
  if ($msg_italic eq 1) { print FILE "<i>"; }
  if ($msg_underline eq 1) { print FILE "<u>"; }
  print FILE "<!--m-->$FORM{'message'}<!--m-->";
  if ($msg_underline eq 1) { print FILE "</u>"; }
  if ($msg_italic eq 1) { print FILE "</i>"; }
  if ($msg_bold eq 1) { print FILE "</b>"; }
  print FILE "</font></p>\n";
#-----------

  foreach $str (@NEWS) {
    print FILE $str;
  }
  flock(FILE, 8); # enabling write access
  close(FILE);

  print "Location: $mainurl\n\n";
}

sub show_news {
  print "Content-Type: text/html\n\n";

  $SIZE = @NEWS;

  if ($query < $SIZE) { $SIZE = $query; }

  for ($i=0;$i<$SIZE;$i++) {
    if ($i ne 0) {
      print "$dividertag\n";
    }
    print $NEWS[$i];
  }

}
